local SpawnPrefab = GLOBAL.SpawnPrefab
local Prefab = GLOBAL.Prefab
local Prefabs = GLOBAL.Prefabs
local FRAMES = GLOBAL.FRAMES
local FOODTYPE = GLOBAL.FOODTYPE

local minseeds = GetModConfigData("minseeds")
local maxseeds = GetModConfigData("maxseeds")

local function OnDigestMOD(inst, item)
	if item.components.edible.foodtype == FOODTYPE.MEAT then
		inst.components.lootdropper:SpawnLootPrefab("bird_egg")
	else
		local seed_name = string.lower(item.prefab .. "_seeds")
		if Prefabs[seed_name] ~= nil then
			local num_seeds = math.random(minseeds, maxseeds)
			for k = 1, num_seeds do
				inst.components.lootdropper:SpawnLootPrefab(seed_name)
			end
		else
			inst.components.lootdropper:SpawnLootPrefab("seeds")
		end
	end
end

local function OnGetItemFromPlayer(inst, giver, item)

	if inst.components.sleeper and inst.components.sleeper:IsAsleep() then
		inst.components.sleeper:WakeUp()
	end

	if item.components.edible ~= nil and
		(	item.components.edible.foodtype == FOODTYPE.MEAT or
			item.prefab == "seeds" or
			Prefabs[string.lower(item.prefab.."_seeds")] ~= nil
		) then
		inst.AnimState:PlayAnimation("peck")
		inst.AnimState:PushAnimation("peck")
		inst.AnimState:PushAnimation("peck")
		inst.AnimState:PushAnimation("hop")
		
		inst.AnimState:PushAnimation("idle_bird", true)
		inst:DoTaskInTime(60 * FRAMES, OnDigestMOD, item)
	end
end

local function modded_birdcage(inst)
	if inst and inst.components.trader then
	inst.components.trader.onaccept = OnGetItemFromPlayer
	end
end

AddPrefabPostInit("birdcage", modded_birdcage)